<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDistritosERP ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfDistritosERP
 * @subpackage Arrays
 */
class ArrayOfDistritosERP extends AbstractStructArrayBase
{
    /**
     * The DistritosERP
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DistritosERP[]
     */
    public $DistritosERP;
    /**
     * Constructor method for ArrayOfDistritosERP
     * @uses ArrayOfDistritosERP::setDistritosERP()
     * @param \StructType\DistritosERP[] $distritosERP
     */
    public function __construct(array $distritosERP = array())
    {
        $this
            ->setDistritosERP($distritosERP);
    }
    /**
     * Get DistritosERP value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DistritosERP[]|null
     */
    public function getDistritosERP()
    {
        return isset($this->DistritosERP) ? $this->DistritosERP : null;
    }
    /**
     * Set DistritosERP value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DistritosERP[] $distritosERP
     * @return \ArrayType\ArrayOfDistritosERP
     */
    public function setDistritosERP(array $distritosERP = array())
    {
        foreach ($distritosERP as $arrayOfDistritosERPDistritosERPItem) {
            // validation for constraint: itemType
            if (!$arrayOfDistritosERPDistritosERPItem instanceof \StructType\DistritosERP) {
                throw new \InvalidArgumentException(sprintf('The DistritosERP property can only contain items of \StructType\DistritosERP, "%s" given', is_object($arrayOfDistritosERPDistritosERPItem) ? get_class($arrayOfDistritosERPDistritosERPItem) : gettype($arrayOfDistritosERPDistritosERPItem)), __LINE__);
            }
        }
        if (is_null($distritosERP) || (is_array($distritosERP) && empty($distritosERP))) {
            unset($this->DistritosERP);
        } else {
            $this->DistritosERP = $distritosERP;
        }
        return $this;
    }
    /**
     * Add item to DistritosERP value
     * @throws \InvalidArgumentException
     * @param \StructType\DistritosERP $item
     * @return \ArrayType\ArrayOfDistritosERP
     */
    public function addToDistritosERP(\StructType\DistritosERP $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DistritosERP) {
            throw new \InvalidArgumentException(sprintf('The DistritosERP property can only contain items of \StructType\DistritosERP, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DistritosERP[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DistritosERP|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DistritosERP|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DistritosERP|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DistritosERP|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DistritosERP|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DistritosERP
     */
    public function getAttributeName()
    {
        return 'DistritosERP';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDistritosERP
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
